package kd.hrmp.hbjm.business.domain.repository;

import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.orm.query.QFilter;
import kd.hr.hbp.business.servicehelper.HRBaseServiceHelper;
import kd.hr.hbp.common.constants.HRBaseConstants;
import kd.hrmp.hbjm.common.constants.HBJMConstants;

import java.util.List;

/**
 * @author rd_ningjie
 * @description:职级数据库操作
 * @date 2022/8/5 9:47
 */
public class JobLevelOrGradeRepository {

    private static class JobLevelInstance {
        private static JobLevelOrGradeRepository INSTANCE = new JobLevelOrGradeRepository();
    }

    public static JobLevelOrGradeRepository getInstance() {
        return JobLevelInstance.INSTANCE;
    }


    /**
     * @param ids
     * @description:
     * @return: kd.bos.dataentity.entity.DynamicObject[]
     * @author rd_ningjie
     * @date: 2022/8/5 9:49
     */
    public DynamicObject[] getLevelByIds(List<Long> ids) {
        HRBaseServiceHelper serviceHelper = new HRBaseServiceHelper(HBJMConstants.PAGE_JOBLEVEL);
        QFilter filter = new QFilter(HRBaseConstants.ID, QFilter.in, ids);
        return serviceHelper.loadDynamicObjectArray(new QFilter[]{filter});
    }

    /**
     * @param scmids
     * @description:根据职级方案id查询职级对象
     * @return: kd.bos.dataentity.entity.DynamicObject[]
     * @author rd_ningjie
     * @date: 2022/8/5 9:49
     */
    public DynamicObject[] getLevelByScmIds(List<Long> scmids) {
        HRBaseServiceHelper serviceHelper = new HRBaseServiceHelper(HBJMConstants.PAGE_JOBLEVEL);
        QFilter filter = new QFilter(HBJMConstants.JOBLEVELSCM + ".id", QFilter.in, scmids);
        return serviceHelper.loadDynamicObjectArray(new QFilter[]{filter});
    }

    /**
     * @param ids
     * @description:
     * @return: kd.bos.dataentity.entity.DynamicObject[]
     * @author rd_ningjie
     * @date: 2022/8/5 9:49
     */
    public DynamicObject[] getGradeByIds(List<Long> ids) {
        HRBaseServiceHelper serviceHelper = new HRBaseServiceHelper(HBJMConstants.PAGE_JOBGRADE);
        QFilter filter = new QFilter(HRBaseConstants.ID, QFilter.in, ids);
        return serviceHelper.loadDynamicObjectArray(new QFilter[]{filter});
    }

    /**
     * @param scmids
     * @description: 根据职等方案id查询职等对象
     * @return: kd.bos.dataentity.entity.DynamicObject[]
     * @author rd_ningjie
     * @date: 2022/8/5 9:49
     */
    public DynamicObject[] getGradeByScmIds(List<Long> scmids) {
        HRBaseServiceHelper serviceHelper = new HRBaseServiceHelper(HBJMConstants.PAGE_JOBGRADE);
        QFilter filter = new QFilter(HBJMConstants.JOBGRADESCM + ".id", QFilter.in, scmids);
        return serviceHelper.loadDynamicObjectArray(new QFilter[]{filter});
    }

}
